#include <stdlib.h>
#include <stdio.h>
#include <avwio.h>

int main(int argc,char* argv[])
{
  short ppl,lpi,ipv,vols,dt,i,j;
  short tppl,tlpi,tipv,tdt,svols;
  char *buffer;
  long volsize;
  AVW *ifp,*ofp;

  if(argc<4){
    printf("Usage: avwcat file1 [file2 ...] -out outfile\n");
    return(1);
  }
  if((!strcmp(argv[1],"-help"))||(!strcmp(argv[1],"-h"))){
    printf("Usage: avwcat file1 [file2 ...] -out outfile\n");
    return(1);
  }
  if(strcmp(argv[argc-2],"-out")){
    printf("Usage: avwcat file1 [file2 ...] -out outfile\n");
    return(1);
  }

  if((ofp=AvwOpen(argv[argc-1],"w"))==NULL){
    printf("Failed to open AVW file: %s\n",argv[argc-1]);
    return(1);
  }
  
  if((ifp=AvwOpen(argv[1],"r"))==NULL){
    printf("Failed to open AVW file: %s\n",argv[1]);
    return(1);
  }
  AvwGetDim(ifp,&ppl,&lpi,&ipv,&vols);
  AvwGetDataType(ifp,&dt);
  volsize = (ppl*lpi*ipv*AvwGetDataType(ifp,&dt))/(8*sizeof(char));
  if((buffer=(char *)malloc(volsize))==NULL){
    printf("Malloc failed\n");
    return(1);
  }

  for(i=0;i<vols;i++){
    if(fread(buffer,1,volsize,ifp->imgfp)!=volsize){
      printf("Read error\n");
      return(1);
    }
    if(fwrite(buffer,1,volsize,ofp->imgfp)!=volsize){
      printf("Write error\n");
      return(1);
    }
  }
  svols=vols;
  AvwCloneHeader(ofp,ifp);
  AvwClose(ifp);

  for(i=2;i<argc-2;i++){
    if((ifp=AvwOpen(argv[i],"r"))==NULL){
      printf("Failed to open AVW file: %s\n",argv[1]);
      return(1);
    }
    AvwGetDim(ifp,&tppl,&tlpi,&tipv,&vols);
    AvwGetDataType(ifp,&tdt);
  
    if((tppl!=ppl)||(tlpi!=lpi)||(tipv!=ipv)){
      printf("File %s data size not compatible with %s\n",argv[i],argv[1]);
      return(1);
    }

    if(tdt!=dt){
      printf("File %s data type not compatible with %s\n",argv[i],argv[1]);
      return(1);
    }

    for(j=0;j<vols;j++){
      if(fread(buffer,1,volsize,ifp->imgfp)!=volsize){
	printf("Read error\n");
	return(1);
      }
      if(fwrite(buffer,1,volsize,ofp->imgfp)!=volsize){
	printf("Write error\n");
	return(1);
      }
    }
    svols+=vols;
    AvwClose(ifp);
  }

  AvwSetDim(ofp,ppl,lpi,ipv,svols);
  AvwClose(ofp);
  return(0);
}
