#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>

#include "mjimage.h"
#include "generalio.h"
#include "interpolation.h"
#include "miscimfns.h"
#include "costfns.h"
#include "newmatap.h"

#include "Globaloptions.h"

using namespace MISCMATHS;
using namespace MISCIMFNS;
using namespace INTERPOLATION;
using namespace COSTFNS;
using namespace NEWMAT;
using namespace MJIMAGE;
using namespace GENERALIO;


//------------------------------------------------------------------------//


int main (int argc,char** argv)
{
  tvolume timeseries;
  volume refvol, anisorefvol, variancevol, meanvol, sigmavol;
  int vmax;
  Globaloptions& globalopts = Globaloptions::getInstance();
  

  cerr << endl << "vmapper v 0.1.1" << endl <<"This software is currently alpha." << endl << "Please send any comments/ queries to: prb@fmrib.ox.ac.uk" << endl << endl;
  globalopts.parse_command_line(argc, argv);
  cerr << "Reading time series... " << endl;
  read_series(timeseries, globalopts.inputfname);
  vmax = timeseries.getSize();
  
  meanvol = timeseries[0];
  variancevol = timeseries[0];
  sigmavol = timeseries[0];
  
  meanvol.reinitialize(timeseries[0].xsize(), timeseries[0].ysize(), (timeseries[0].zsize() - 2));
  variancevol.reinitialize(meanvol);
  sigmavol.reinitialize(meanvol);
  
  meanvol = 0.0;
  variancevol = 0.0;
  sigmavol = 0.0;

  cerr << "This version has been hacked for AIRcorrected data." << endl  
       << "The end slices are ignored when calculating mean and variance statistics" << endl;

  // calculate the mean value and variance at each voxel
  for (int x=0; x< timeseries[0].xsize(); x++) {
    for (int y=0; y< timeseries[0].ysize(); y++) {
      for (int z=0; z< (timeseries[0].zsize()-2); z++) {
	for (int i=0; i< vmax; i++) 
	  meanvol(x,y,z) = meanvol(x,y,z) + timeseries[i](x,y,z+1);
	meanvol(x,y,z) = meanvol(x,y,z)/(float)vmax;
	for (int i=0; i< vmax; i++)
	  variancevol(x,y,z) = variancevol(x,y,z) + (timeseries[i](x,y,z+1) - meanvol(x,y,z))*(timeseries[i](x,y,z+1) - meanvol(x,y,z));
	variancevol(x,y,z) = variancevol(x,y,z)/((float)(vmax - 1));
	sigmavol(x,y,z) = sqrt(variancevol(x,y,z));
      }
    }
  }

  cerr << "Saving mean volume... " << endl;
  save_volume(meanvol, "mean_"+globalopts.inputfname);

  cerr << "Saving variance volume... " << endl;
  save_volume(variancevol, "variance_"+globalopts.inputfname);

  cerr << "Saving standard deviation volume... " << endl;
  save_volume(sigmavol, "sigma_"+globalopts.inputfname);

}






